use Style;
use Util;
use syscfg;
use CSV;
my @dd;
my @lang = glob(Util::bindir().'/datadict_*.xml'); # /datadict_*.xml
@dd = map { DataDict->new($_) } @lang;
my $home = OS::gethome('sikurs').OS::slash();
my $htm = $home.'ddvar.htm';
my $csv = $home.'ddvar.csv';
my %EVA; # Excel-Beispiel Variabalennamen Anpassung
CSV::iterate(
    syscfg::get('DEFAULTS.Directory', '').'EVA.csv',
    sub { my $fld = shift; $EVA{$fld->[0]} = $fld->[1]; return 1; }
);
my $haveEVA = scalar keys %EVA;
#say dump('EVA', \%EVA);
if (open(my $H, '>', $htm) and open(my $C, '>', $csv)) {
print {$H} <<EOD;
<html>
<head>
<title>SIKURS Variablennamen</title>
</head>
<style>
h1, h2 {
    color: #B82619;
    background-color: #EAE2BB;
}
td {
    color: #2F2F2F;
    background: #E7E7F7;
    padding: 1px 7px 1px 7px;
}
th {
    text-align: left;
    font-family: monospace;
    font-weight: normal;
    color: #3F2F2F;
    background: #D7E7F7;
    padding: 1px 7px 1px 7px;
}
.tooltip { color: blue; }
</style>
<body>
<a href="http://sikurs.pthaug.de/dot/index.htm">Datenflußgraph mit Namenssystematik</a><br>
<h1>SIKURS Variablennamen</h1>
<p>
als csv-Tabelle <a href="ddvar.csv">ddvar.csv</a>
</p>
<table>
<tr><th><a title="Variablennamen SIKURS-Programm"><span class=tooltip>VNSP</span></a></th>
EOD

print {$H} '<th><a title="Variablennamen EVA.csv für EXCEL-Doku"><span class=tooltip>VNED</span></a></th>' if $haveEVA;
print {$C} "#Name";
print {$C} ';EVA.csv' if $haveEVA;
foreach (@lang) {
    my ($fn, $path) = fileparse($_);
    printf {$H} "<th>%s</th>", $fn;
    printf {$C} ";%s", $fn;
}
print {$H} "</tr>\n";
print {$C} "\n";

my %both;
my $pat = '^[A-Z0-9]*[_svn]?$';
foreach my $d (@dd) {
    foreach (keys %{$d}) {
        $both{$_} = undef if length($_) > 2 and m/$pat/;
    }
}
foreach my $k (sort keys %both) {
    printf {$H} "<tr><th>%s</th>", $k;
    printf {$C} '%s', $k;
    if ($haveEVA) {
        my $e = $EVA{$k} // '';
        printf {$H} '<th>%s</th>', $e;
        printf {$C} ';%s', $e;
    }
    foreach (@dd) {
        printf {$H} "<td>%s</td>", $_->{$k} // '';
        printf {$C} ";%s", $_->{$k} // '';
    }
    printf {$H} "</tr>\n";
    printf {$C} "\n";
}

print {$H} <<EOD;
</table>
</body>
</html>
EOD
close $H;
close $C;
}
OS::browse($htm);
__END__

=head1 Variablennamen

Ausgabe der Variablen m/^[A-Z0-9]*[_s]?$/ von datadict_de.xml
