use utf8;
use Style;
use Data::Dump qw(dump);
use DD;

my %entry;
my %label;
my %var;
init(qw(A ANPASSUNG_WEGZUG));
init(qw(B ANPASSUNG_ZUZUG));
init(qw(C ZIELWERT_WEGZUG));
init(qw(D NEUBAU));
init(qw(E RUECKBAU));
init(qw(G GEBURTENECKWERT));
init(qw(I BINNENWANDERUNG));
init(qw(K AUSSENWANDERUNGSDATEN));
init(qw(N ZIELWERT_AUSSENWANDERUNGSSALDO));
init(qw(M ZIELWERT_BESTAND));
init(qw(P ZIELWERTE));
init(qw(R ANSTALTSBEVOELKERUNG));
init(qw(S STERBEECKWERT));
init(qw(T BEVOELKERUNGSBEWEGUNGEN));
init(qw(V ATRAKTIVITAET));
init(qw(W BEVGRPWECHSEL));
init(qw(Y BGWQG));
my $NTYA = vercfg::get('METHODE.NTYA',  1);
my $NBG  = vercfg::get('METHODE.NBG',   2);
my $NGG  = vercfg::get('METHODE.NGG',   2);
my $NAG  = vercfg::get('METHODE.NAG', 100);
#say dump($NTYA, $NBG, $NGG, $NAG);
my @pfb = qw/-fill both/;
my @paw = qw/-anchor w/;
my @psl = qw/-side left/;
my ($dialog, $bframe) = tkx()->dialogbox('Methodenwahl '.syscfg::get('DEFAULTS.Directory').syscfg::get('DEFAULTS.Version'));
my $fit = $dialog->new_ttk__labelframe(-text => 'Anpassung an Zielwerte')->pack(@pfb);
my $move = $dialog->new_ttk__labelframe(-text => 'Bevölkerungsbewegung')->pack(@pfb);
Tkx::tooltip__tooltip($move, 'Geburt, Alterung, Tod werden immer berechnet');

my $cbe = sub {
    my ($frame, $bs) = @_;
    $entry{$bs} = $frame->new_ttk__checkbutton(
        -text => cbtext($bs),
        -padding => '10 0 0 0',
        -variable => \$var{$bs},
        -command => sub {
            $entry{$bs}->configure(-text => cbtext($bs));
            check();
        }
    );
    Tkx::tooltip__tooltip($entry{$bs}, tt($bs, 1));
    $entry{$bs}->pack(@paw);
};
my $ent = sub {
    my ($frame, $bs, $max) = @_;
    my $f = $frame->new_ttk__frame;
    $entry{$bs} = $f->new_ttk__spinbox(
        -textvariable => \$var{$bs},
        -width => 0,
        -show => ' ',
        -from => 0,
        -to => $max,
        -command => sub {
            $label{$bs}->configure(-text => cbtext($bs));
            check();
        }
    )->pack(@psl);
    $label{$bs} = $f->new_ttk__label(-text => cbtext($bs))->pack(@psl);
    Tkx::tooltip__tooltip($f, tt($bs, $max));
    $f->pack(@paw);
};
#$cbe->($move, 'T');
Tkx::tooltip__tooltip($fit, 'Auswahl der Bewegungen für die Anpassung');
$cbe->($fit,  'A');
$cbe->($fit,  'B');
$ent->($move, 'K', 6);
$cbe->($move, 'I');
$cbe->($move, 'D');
$ent->($move, 'E', 2);
$ent->($move, 'R', 2);
$cbe->($move, 'W');
$cbe->($move, 'Y');
my $goal = $dialog->new_ttk__labelframe(-text => 'Zielwerte')->pack(@pfb);
Tkx::tooltip__tooltip($goal, 'Anpassung der Bevölkerungsbewegung an Zielwerte');
$ent->($goal, 'M', 2);
$ent->($goal, 'N', 4);
$ent->($goal, 'C', 6);
$ent->($goal, 'P', 2);
$ent->($goal, 'G', 2);
$ent->($goal, 'S', 2);
my $att = $dialog->new_ttk__labelframe(-text => 'Attraktivität')->pack(@pfb);
Tkx::tooltip__tooltip($fit, 'Auswahl der Bewegungen für die Anpassung');
$cbe->($att, 'V');
my $vars = $dialog->new_ttk__labelframe(-text => 'Anzahl')->pack(@pfb);
Tkx::tooltip__tooltip($vars, "Differenzierung der Eingabedaten\nnach demografischen Merkmalen\nund Anzahl Außengebieten");
$vars->labelentry('NTYA', -textvariable => \$NTYA, -width => 5)->pack(@paw);
$vars->labelentry('NBG',  -textvariable => \$NBG,  -width => 5)->pack(@paw);
$vars->labelentry('NGG',  -textvariable => \$NGG,  -width => 5)->pack(@paw);
$vars->labelentry('NAG',  -textvariable => \$NAG,  -width => 5)->pack(@paw);
check();
my @b = $bframe->okbutton(
    sub {
        $dialog->g_destroy;
    },
    sub {
        $dialog->g_destroy;
        wprint("Abbruch\n");
    },
    whelp()
);
Tkx::MainLoop();
sub check {
    _eq(qw(T A));
    _eq(qw(I P));
    _eq(qw(I D));
    _eq(qw(I E));
    _ne(qw(P V));
    _ne(qw(M N));
    _ne(qw(M C));
    _ne(qw(N M));
    if ($var{N} == 0) {
        $entry{K}->configure(-from => 0, -to => 6);
    } elsif ($var{N} == 1) {
        if ($var{A} == 0) {
            $entry{C}->configure(-state => 'normal');
        } else {
            $var{C} = 0;
            $entry{C}->configure(-state => 'disabled');
        }
        $var{K} = 1;
        $entry{K}->configure(-from => 1, -to => 1);
    } else {
        $var{K} = 2 if $var{K} < 2;
        $entry{K}->configure(-from => 2, -to => 6);
    }
    if ($var{A} == 0 and $var{B} == 0) {
        $var{M} = $var{N} = 0;
        $entry{M}->configure(-state => 'disabled');
        $entry{N}->configure(-state => 'disabled');
    } else {
        $entry{M}->configure(-state => 'normal');
        $entry{N}->configure(-state => 'normal');
    }
}
sub _eq {
    my ($a, $b) = @_;
    $var{$b} = 0 unless $var{$a};
    $entry{$b}->configure(-state => $var{$a} ? 'normal' : 'disabled');
}
sub _ne {
    my ($a, $b) = @_;
    $var{$b} = 0 if $var{$a};
    $entry{$b}->configure(-state => $var{$a} ? 'disabled' : 'normal');
}

sub cbtext {
    my @l = @_;
    return $l[0].$var{$l[0]}.' '.DD::get($l[0]).' - '.DD::get($l[0].$var{$l[0]});
}

sub tt {
    my ($bs, $max) = @_;
    return join("\n",
        $bs.': '.DD::get($bs.'?'),
        map { $bs.$_.': '.DD::get($bs.$_.'?')} (0 .. $max)
    );
}

sub init {
    my ($bs, $name) = @_;
    my $b = vercfg::get('METHODE.'.$name, $bs.'0');
    $var{$bs} = substr($b, 1);
}

1;
__END__

=head1 assi

=for html
Experiment alternative Methodenwahl
<ul>
<li>Baustein T entfernt
<li>Baustein K0 entfernt
<li>alle Entscheidungen auf einer Seite
</ul>
Noch moderner wäre die Methodenwahl in einen chat bot zu integrieren
"hey SIKURS, mach mal ne Variantenprognose mit Zielwerten und Rückbau" ;-)

