:: Start Subsysteme des C++-Programms ...\sikurs\App\sikern64.exe
:: %EXE% <subsystem>
:: mit subsystem:
::   sikern [-c -v version -d C:\...\prog -w C:\...\sikurs]
::     Bevlkerungsprognose mit Parametern
::     -c fhre Befehle vor/nach Prognose aus
::     -v Versionsname Prognose
::     -d Verzeichnisname Prognose
::     -w Arbeitsverzeichnis
::   hhprog <parameter>
::     Haushalteprognose mit Parametern
::     -d dir : Eingabeverzeichnis
::     -F 4   : signifikante Ziffern R02
::     -M 1   : Ausgabe Micromerkmale
::     -N 1   : Stze mit W04 = 1 verarbeiten
::     -O 65  : obere Altersgrenze
::     -P 1   : Prognose
::     -Q 1   : Quotenberechnung
::     -R 1   : Zeitreihenplot
::     -T 3   : Typspalte
::     -U 35  : untere Altersgrenze
::     -V 2   : Protokollumfang
::     -w C:\...\sikurs : Arbeitsberzeichnis
::   dstmak <funktion>
::     Verarbeite DST-Dateien
::     list   : Anlisten DST-Datei
::     makro  : ableiten Makrodateien
::     indio  : berechne Indikatoren
::   shp2plt <parameter>
::     Erzeuge thematische Karte aus shapefile und Daten
::     -a area
::        3,4,5:r,g,b:*:* Merkmalnummer 3,4,5, Farbpalette rgb-Formel r,g,b, cbrange *:*
::        7:#:            Merkmalsnummer 7 enthlt rgb-code, ohne cbrange
::     -c 1  : copy dbf to csv
::     -d chart diagram
::        1,5.4[,6] bar chart size 5.4 [times attribute 6]
::        2,1.3,50  pie chart hight factor 1.3, width 50  
::     -g gnuplot terminal
::        wxt:800:Arial,8:#F0F0F0
::          wxt: terminal type (see gnuplotTerm)
::          800: height
::          Arial,8 Font
::          #F0F0F0 background color
::     -l 1  : list attribute names
::     -p ,  : Dezimalkomma
::     -r ;  : Spaltentrennzeichen
::     -s fn.shp : shape file name
::     -t text
::        3,4,5:100:Arial12
::           Merkmalnummern: SVG-Fontsize: gnuplot Font
@echo off
echo Batch-Lauf fr mehrere SIKURS-Prognosen
if not %1.==. goto good
echo: Aufruf: batch.bat C:\...\sikurs (Sikurs-Wurzelverzeichnis)
goto end
:good
set ROOT=%1
set EXE=%ROOT%\App\sikern64.exe
echo %ROOT% ist das Sikurs-Wurzelverzeichnis

echo 1. Prognose:
%EXE% sikern -d %ROOT%\beispiel\regtest\ -v T1
del %ROOT%\beispiel\regtest\T1\prot.tmp

echo 2. Prognose (-c: Befehle CALLBACK0/2 aus ini-Datei werden ausgefhrt):
%EXE% sikern -c -d %ROOT%\beispiel\beisp_1\ -v Handbuch
del %ROOT%\beispiel\beisp_1\Handbuch\prot.tmp

echo 3. Haushalte-Quotenberechnung und -Prognose
%EXE% hhprog -d %ROOT%\beispiel\hhprog\ -Q 1 -P 1
del %ROOT%\beispiel\hhprog\prot.tmp

echo weitere mgliche batch jobs ...
:end
set ROOT=
set EXE=
PAUSE
