use utf8;
use Style;

my $stz = loc::get('record_separator');
my $directory = syscfg::get('DEFAULTS.Directory', '');
my $foundFile = tkx()->getOpenFile(
    -initialdir => OS::osPath($directory),
    -title      => "Bitte wählen Sie eine Eingabedatei"
);
if ($foundFile ne '') {
    my (@fld, $v, $i, $ag);
    if (open(my $F, '<:encoding(UTF-8)', $foundFile)) {
        wprint($foundFile, ":\n");
        my ($fn, $dir) = fileparse($foundFile);
        my $outFile = tkx()->getSaveFile(
            -initialdir => $dir,
            -title      => "Bitte wählen Sie eine Ausgabedatei"
        );
        if ($outFile ne '') {
            die "can not overwrite\n" if $foundFile eq $outFile;
            open (my $O, '>:encoding(UTF-8)', $outFile) or die "open $outFile $!";
            printf {$O} << "EOT", &OS::timeString, $foundFile;
# %s
# bev2pivot.pl
# < %s
EOT
            my $FELDER = 18; # incl Jahr;Geb;BG;GG;AG
            my $NBEW   = 13; # Anzahl Bewegungen
            my (@data, @ix, @ages);
            RECORD:
            while (<$F>) {
                if (m/^#/) {
                    wprint($_);
                    if (m/^#Jahr/) {
                        # Spaltenüberschriften der Indices aber ohne Bewegungen
                        chomp;
                        @fld = split $stz;
                        if (scalar(@fld) != $FELDER) {
                            wprintf("Anzahl Felder von %d auf %d geändert\n", $FELDER, scalar(@fld));
                            $FELDER = scalar(@fld);
                        }
                        my $b = 0;
                        foreach (@fld) {
                            if (m/^\(/) {
                                printf {$O} "# %02d %s\n", ++$b, $_;
                            }
                        }
                        if ($b != $NBEW) {
                            wprint("Anzahl Bewgungen von $NBEW auf $b geändert\n");
                            $NBEW = $b;
                        }
                        print {$O} join($stz, @fld[0 .. $#fld-$NBEW], qw(Bewegungsart Wert)), "\n";
                    }
                    next RECORD;
                }
                chomp;
                @fld = split $stz;
                if ($#fld < 1) {
                    next RECORD;
                }
                foreach my $b (0 .. $NBEW-1) {
                    foreach my $i (0 .. $FELDER - $NBEW - 1) {
                        print {$O} $fld[$i], $stz;
                    }
                    printf {$O} "%02d%s", $b+1, $stz;
                    print  {$O} $fld[$b-$NBEW] // '', "\n";
                }
            }
            close $O;
            close $F;
        }
        wprint("> $outFile\n");
    } else {
        wprint("can not open $foundFile $!");
    }
}
1;
__END__

=head1 bew2pivot

Lese Datei bew, bewagg, bewgem (aber nicht bewgemagg)
und ordne nebeneinander liegende Bewegungsspalten in Ausgabdatei
mit neuer Spalte Bewegungsart untereinander an.

Diese Anordung eignet sich für Pivot-Tabellen oder z.B. 
Visualisierung/Zeitreihen/Histogramm
