use utf8;
use Style;
use List::MoreUtils qw(pairwise);
use Time::HiRes qw(gettimeofday tv_interval);

my $directory = syscfg::get('DEFAULTS.Directory', '');
my $foundFile = tkx()->getOpenFile(
    -initialdir       => OS::osPath($directory),
    -title            => "Bitte wählen Sie eine Datei"
);

my ($recs, $sum, $cmnts, $empty) = (0, 0, 0, 0);
my (@minimum, @maximum, @cmnts, @firstrecs, $lastrec);

# verarbeite eine Eingabezeile
my $pline = sub {
    my $l = shift;
    CSV::combine(@$l);
    my $line = CSV::string();
    my $fld  = CSV::float($l, sub { wprint('Warning: ', @_, "\n"); } );
    my $f = 0;
    if (scalar(@$fld) > 0) {
        $fld->[-1] += 0;
        $sum += $fld->[-1];
        $recs++;
        push @firstrecs, $line if $recs <= 3;
        my @a_ = map { $_ eq '' ? 0 : $_ } @$fld; # bew hat leere Felder
        @minimum = pairwise { min($a, $b // +1e60) } @a_, @minimum;
        @maximum = pairwise { max($a, $b // -1e60) } @a_, @maximum;
        $lastrec = $line;
    } else {
        $empty++;
    }
    return 1;
};

my $pcmnt = sub {
    $cmnts++;
    CSV::combine(@{$_[0]});
    push @cmnts, CSV::string();
    return 1;
};

if ($foundFile ne '') {
    my $t1 = [gettimeofday];
    if (CSV::iterate($foundFile, $pline, $pcmnt)) {
        wprint($foundFile, CSV::encoding(' (%s)'), ":\n");
        wprint(@cmnts, @firstrecs);
        wprintf("...\n%s", $lastrec) if $recs > 2;
        wprintf("%d Sätze (%d Kommentar, %d Daten, %d Leer) Summe = %f\n", $cmnts + $recs + $empty, $cmnts, $recs, $empty, $sum);
        wprint((pairwise { '['.(($a == $b) ? $a : $a.'..'.$b).']' } @minimum, @maximum), "\n");
    } else {
        wprint("can not open $foundFile $!\n");
    }
    wprint("time ", tv_interval($t1), " ms\n");
}
1;
__END__

=head1 count

Zähle Sätze einer csv-Datei mit Minimalstatistik
