use utf8;
use List::Util qw(sum max);
use Style;
use frequency;
use syscfg;
use Tkxsik;
use DD;

my $directory = syscfg::get('DEFAULTS.Directory', '');
my $foundFile;
$foundFile = ::tkx()->getOpenFile(
    -initialdir  => ::OS::osPath($directory),
    -title => "bitte wählen Sie eine (zr_)gem-, dsga- oder Makro-Datei"
);
if ($foundFile ne '') {
    my ($fn, $dir, $ext) = fileparse($foundFile, qr/\.[^.]*/x);
    my ($dialog, $bframe) = tkx()->dialogbox('Indikator');
    my %opt = (
        AG => [
            1,
            'Indikatoren Altersstruktur',
            "${fn}_AG.csv:\nSumme, unterste-, oberste-Altersgruppe,\nDurschnitts-, Modal-, Median-alter, Altersvarianz, Billeter-J,\nJugend-, Alters-quotient"
        ],
        BG => [
            1,
            'Anteil Bevölkerungsgruppe 2 pro Altersgruppe',
            "${fn}_BG.csv:\nmeist Ausländeranteil"
        ],
        GP => [
            1,
            'Geschlechterproportion pro Altersgruppe',
            "${fn}_GP.csv:\nMännersüberschuss bei Geburt und Frauenüberschuß in hohen Alter"
        ],
        debug => [
            0,
            'debug',
            'zusätzliche Ausgaben zum nachrechnen',
        ]
    );
    $dialog->checkbutton([$opt{$_}[1], $opt{$_}[2]], -variable => \$opt{$_}[0])->pack(-anchor => 'w') foreach qw(AG BG GP debug);
    $bframe->okbutton(
        sub {
            $dialog->g_destroy;
            foreach (qw(AG BG GP)) {
                if ($opt{$_}[0]) {
                    my $out = $dir.$fn.'_'.$_.$ext;
                    unless (open $opt{$_}[3], '>:encoding(UTF-8)', $out) {
                        wwarn("Error: open $out $!\n");
                        return;
                    }
                }
            }
            if ($opt{AG}[0] or $opt{BG}[0] or $opt{GP}[0]) {
                my ($cmnts) = (0, 0, 0);
                my ($v, @min, @max, $i, $sum);
                my %data;
                my @cmnt;
                my $pline = sub {
                    my $fld = CSV::float(shift, \&Carp::croak);
                    if (scalar(@$fld) > 7) {
                        CSV::set_errmsg("Datei $foundFile sollte hoechstens 7 Spalten haben\n".join(';', @$fld));
                        return -1;
                    }
                    my @f = @$fld;
                    unshift @f, '' while scalar(@f) < 7;
                    #say dump(@f);
                    $data{$f[0]}{$f[1]}{$f[2]}{$f[3]}{$f[4]}[$f[5]] = $f[6];
                    return 1;
                };
                my $pcmnt = sub {
                    my $l = shift;
                    @cmnt = @$l if CSV::iscolhead($l);
                    return 1;
                };
                wprint("< $foundFile\n");
                wprintf("> %s%s_%s%s\n", $dir, $fn, $_, $ext) foreach qw(AG BG GP); 
                my $NBG = 0;
                if ($opt{debug}[0]) {
                    # find $NBG
                    CSV::iterate(
                        $foundFile,
                        sub {
                            my $fld = CSV::float(shift, \&Carp::croak);
                            $NBG = max($fld->[-4] // 0, $NBG);
                            return 1;
                        },
                        sub {
                            return 1;
                        }
                    );
                }
                if (CSV::iterate($foundFile, $pline, $pcmnt)) {
                    #say dump(%data);
                    my $NAGWU   = syscfg::get('INDIKATOR.NAGWU', 20);
                    my $NAGWO   = syscfg::get('INDIKATOR.NAGWO', 64);
                    my $VERBOSE = syscfg::get('TRACE.VERBOSE',    0);
                    if (scalar @cmnt) {
                        $cmnt[0] =~ s/^#//;
                        # BG
                        my @cmntBG = @cmnt;
                        pop @cmntBG; # Anzahl
                        my $ag = pop @cmntBG;
                        my $gg = pop @cmntBG;
                        pop @cmntBG; # Bevölkerungsgruppe
                        push @cmntBG, $gg, $ag;
                        my $ind = 'Indikator ';
                        if ($opt{debug}[0]) {
                            my $tBG = 'Anzahl und Anteil BG (Bevölkerungsgruppen)';
                            push @cmntBG, (map { 'Anzahl BG '.$_ } (1 .. $NBG)), (map { "Anteil BG ".$_ } (1 .. $NBG));
                            Util::asu($opt{BG}[3], \@cmntBG, $ind.$tBG) if $opt{BG}[0];
                        } else {
                            my $tBG = 'Anteil Bevölkerungsgruppe 2';
                            push @cmntBG, $tBG;
                            Util::asu($opt{BG}[3], \@cmntBG, $ind.$tBG) if $opt{BG}[0];
                        }
                        # GP
                        my @cmntGP = @cmnt;
                        pop @cmntGP; # Anzahl
                        $ag = pop @cmntGP;
                        pop @cmntGP; # Geschlechtsgruppe
                        my $tGP = 'Geschlechterproportion GP';
                        my @valcol = ($tGP);
                        if ($opt{debug}[0]) {
                            unshift @valcol, 'Männer', 'Frauen';
                            push    @valcol, 'Sigma', 'Sigma*';
                        }
                        push @cmntGP, $ag, @valcol;
                        Util::asu($opt{GP}[3], \@cmntGP, $ind.$tGP) if $opt{GP}[0];
                        # AG
                        pop @cmnt foreach (0 .. 1);
                        my @indi1 = qw(sum AGmin AGmax averageAge modeAge medianAge varianceAge billeter_J);
                        my @indi2 = ($VERBOSE > 1) ? ('0..'.($NAGWU-1), $NAGWU.'..'.$NAGWO, ($NAGWO+1).'+') : ();
                        my @indi3 = qw(tkindi_fert_JQ tkindi_fert_AQ);
                        push @cmnt, map { DD::get($_) } @indi1, @indi2, map { DD::get($_) } @indi3;
                        #CSV::print($opt{AG}[3], \@cmnt) if $opt{AG}[0];
                        Util::asu($opt{AG}[3], \@cmnt, 'Indikatoren Altersstruktur') if $opt{AG}[0];
                    }
                    foreach my $i0 (sort keys %data) {
                        foreach my $i1 (sort {$a <=> $b} keys %{$data{$i0}}) {
                            foreach my $i2 (sort {$a <=> $b} keys %{$data{$i0}{$i1}}) {
                                my @BGanz; # Ausländer pro Geschlecht und Altersgruppe
                                foreach my $i3 (sort {$a <=> $b} keys %{$data{$i0}{$i1}{$i2}}) {
                                    my @GPval;
                                    foreach my $i4 (sort {$a <=> $b} keys %{$data{$i0}{$i1}{$i2}{$i3}}) {
                                        my @ix = ($i0, $i1, $i2, $i3, $i4);
                                        shift @ix while $ix[0] eq '';
                                        my $ag = $data{$i0}{$i1}{$i2}{$i3}{$i4}; 
                                        push @ix, sum( map { $_ // 0 } @$ag); # Summe
                                        my ($uag, $oag) = (1000, -1);
                                        foreach (0 .. $#$ag) {
                                            if (defined $_) {
                                                $uag = $_ if $_ < $uag;
                                                $oag = $_ if $_ > $oag;
                                            }
                                        }
                                        my $mode = frequency::mode($ag);
                                        push @ix, $uag, $oag,
                                        frequency::mean($ag),
                                        defined($mode) ? $mode + 0.6 : '',
                                        frequency::median($ag),
                                        frequency::variance($ag),
                                        frequency::billeter_J($ag);
                                        my @n = frequency::JQAQ($ag, syscfg::get('INDIKATOR.NAGWU', 20), syscfg::get('INDIKATOR.NAGWO', 64));
                                        push @ix, @n if $VERBOSE > 1;
                                        if ($n[1] != 0) {
                                            push @ix, $n[0]/$n[1], $n[2]/$n[1]; # JQ, AQ
                                        }
                                        CSV::print($opt{AG}[3], \@ix) if $opt{AG}[0];
                                        foreach (0 .. $#$ag) {
                                            my @v;
                                            my $m = $data{$i0}{$i1}{$i2}{$i3}{1}[$_] // 0;
                                            my $w = $data{$i0}{$i1}{$i2}{$i3}{2}[$_] // 0;
                                            push @v, $m, $w if $opt{debug}[0];
                                            my $s = $m + $w;
                                            $v[$opt{debug}[0] ? 2 : 0] = $m / $s if $s != 0;
                                            if ($opt{debug}[0]) {
                                                $v[3] = 1000 * $m / $w if $w != 0;
                                                $v[4] = 1000 * $w / $m if $m != 0;
                                            }
                                            $GPval[$_] = \@v;
                                        }
                                        foreach (0 .. $#$ag) {
                                            $BGanz[$i4-1][$_][$i3-1] += $data{$i0}{$i1}{$i2}{$i3}{$i4}[$_] // 0; 
                                        }
                                    }
                                    #say dump($i1, $i2, $i3, \@GPval);
                                    if ($opt{GP}[0]) {
                                        foreach (0 .. $#GPval) {
                                            CSV::print($opt{GP}[3], [$i1, $i2, $i3, $_, map { $_ // '' } @{$GPval[$_]}]);
                                        }
                                    }
                                }
                                #say dump($i0, $i1, $i2, \@BGanz);
                                if ($opt{BG}[0]) {
                                    for my $gg (0 .. $#BGanz) {
                                        foreach my $a (0 .. $#{$BGanz[$gg]}) {
                                            my $bgsum = sum(map { $_ // 0 } @{$BGanz[$gg][$a]}) // 0;
                                            if ($opt{debug}[0]) {
                                                CSV::print($opt{BG}[3], [$i1, $i2, $gg+1, $a, (map { $_ // '' } @{$BGanz[$gg][$a]}[0 .. $NBG-1]), (map { ($_ // 0) / $bgsum } @{$BGanz[$gg][$a]}[0 .. $NBG-1])]) if $bgsum != 0;
                                            } else {
                                                my $bg2 = $BGanz[$gg][$a][1] // 0;
                                                CSV::print($opt{BG}[3], [$i1, $i2, $gg+1, $a, $bg2/$bgsum]) if $bgsum != 0;
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                } else {
                    werror(CSV::errmsg(), "\n");
                }
                foreach (qw(AG BG GP)) {
                    close $opt{$_}[3] if $opt{$_}[0];
                }
            }
        },
        sub {
            $dialog->g_destroy;
            wprint("Abbruch\n");
        },
        whelp(),
    );
    Tkx::MainLoop();

}
1;
__END__

=head1 Indikator

=for html
Berechne Indikatoren von Dateien mit demografisch differenzierten
Bevölkerungszahlen, wie z.B.
<ul>
<li>gem- oder dsga-Dateien oder deren Aggregate wie zr_gem</li>
<li>Makrodateien bestand, dsg, nettobestand, aussenwegzug, aussenzuzug,
bgw, binnenwegzug, neubaubezug, sterb oder deren Aggregate.</li>
</ul>
Die Indikatoren beziehen sich auf
<ul>
<li>Altersstruktur: Summe, unterste-, oberste-Altersgruppe, Durschnitts-,
Modal-, Median-alter, Altersvarianz, Billeter-J, Jugend-, Alters-quotient</li>
<li>Geschlechterproportion GP (Männer / (Männer + Frauen)) pro
(evtl. aggregierter) Altersgruppe<br>
Bei einer Prognose beginnt GP in Altersgruppe 0 mit dem vorgegebenen
Wert <em>Geschlechterproportion Geburt</em> (default 0,512) und sinkt dann
insbesondere in hohen Altersgruppen deutlich unter 0,5<br>
bei Option debug werden zuätzlich M (Anzahl Männer), F (Anzahl Frauen),
&Sigma; = 1000 * M / F, &Sigma;* = 1000 * F / M ausgegeben</li>
<li>Anteil BG (Bevölkerungsgruppe) 2 an Summe über die BG
(sinnvoll bei 2 BG, z.B. 1 Deutsche, 2 Ausländer)
pro (evtl. aggregierter) Altersgruppe<br>
bei Option debug werden Anzahl BG und Anteil BG für alle BG ausgegeben</li>
</ul>
Die Ausgabedateien lassen sich mit Visualisierung|Zeitreihen|X/Y-Plot
mit den möglichen Zeitachsen Jahr und Altersgruppe visualisieren
