use utf8;
use Style;

my $directory = syscfg::get('DEFAULTS.Directory', '');
my @foundFiles = tkx()->getOpenFile(
    -initialdir  => ::OS::osPath($directory),
    -defaultextension => 'strb*.csv',
    -multiple => 1,
    -title => "bitte wählen Sie eine oder mehrere strb-Dateien (Sterberaten)"
);
my $n = 1;
foreach my $f (sort @foundFiles) {
    my ($base, $dir, $ext) = fileparse($f, qr/\.[^.]*/x);
    if ($base =~ m/(\d\d\d\d)/) {
        $n = $1;
    } else {
        ++$n;
    }
    my @cmnt;
    my (@min, @max, $i, $sum);
    my %strb;
    my $stz = CSV::STZ();
    my $pline = sub {
        my $fld = CSV::float(shift, \&Carp::croak);
        my $v = pop @$fld;
        my $ag = pop @$fld;
        $strb{join($stz, @$fld)}[$ag] = $v;
        return 1;
    };
    my $pcmnt = sub {
        my $fld = shift;
        my $n = scalar @$fld;
        if ($n > 2 and scalar(@cmnt) == 0) {
            pop @$fld;
            pop @$fld;
            @cmnt = @$fld;
            $cmnt[0] =~ s/^#// if scalar @cmnt;
        }
        return 1;
    };
    wprint("< $f:\n");
    if (CSV::iterate($f, $pline, $pcmnt)) {
        # berechnet Lebenserwartung (Anzahl Jahre bis Tod)
        # Andere Differenzierung als die Datei strb ist nicht sinnvoll/möglich
        wprint(join($stz, '#Jahr', @cmnt, 'Lebenserwartung', 'Charakteristische Lebensdauer'), "\n");
        foreach my $k (sort keys %strb) {
            # Lebenserwartung ab 0 berechnen
            my @s = map { $_ // 0 } @{$strb{$k}};
            wprint(join($stz, $n, $k,
                    frequency::lifespan(\@s),
                    frequency::typical_lifespan(\@s)), "\n");
            my @le = frequency::lifespan_diff(\@s);
            foreach (0 .. $#s) {
                print join($stz, $n, $k, $_, $le[$_]), "\n";
            }
        }
    } else {
        werror(CSV::errmsg(), "\n");
    }
}
1;
__END__

=head1 lebenserwartung

=for html
Berechne Lebenserwartung (Summe(akkumulierte Überlebenswahrscheinlichkeit)+0,5)
und Charakteristische Lebensdauer T nach Weibull
aus einer strb-Datei<br>
Vergleiche leicht abweichendes Verfahren in le_statis.pl
