use utf8;
use Style;
use CSV;

my $stz = CSV::STZ();
my $directory = syscfg::get('DEFAULTS.Directory', '');
my $foundFile = tkx()->getOpenFile(
    -initialdir  => OS::osPath($directory),
    -title => "please select input file"
);
if ($foundFile ne '') {
    my $answer;
    my $delori = 0;
    CSV::iterate(
        $foundFile,
        sub {
            my $l = shift;
            wprint(CSV::string()) if CSV::combine(@$l);
            $answer = join($stz, map { '#'.$_ } (1 .. scalar(@$l)));
            return 0;
        },
        sub {
            my $l = shift;
            wprint(CSV::string()) if CSV::combine(@$l);
            return 1;
        }
    );
    my ($dialog, $bframe) = tkx()->dialogbox('Tausche Spalten');
    $dialog->labelentry( "Struktur Ausgabedatei", -textvariable => \$answer, -width => 20)->pack(-anchor => 'w');
    $dialog->checkbutton('lösche Original', -variable => \$delori)->pack(-anchor => 'w');
    $bframe->okbutton(
        sub {
            $dialog->g_destroy;
            unlink $foundFile.'~';
            rename $foundFile, $foundFile.'~';
            open(my $OUT, '>', $foundFile) or die "open $foundFile $!";
            my @ix = split $stz, $answer;
            my $n = 0;
            my $work = sub {
                my $fld = shift;
                my @fld2;
                $n++;
                if ($#$fld == $#ix) {
                    foreach my $i (0 .. $#ix) {
                        if ($ix[$i] =~ /#(\d+)/) {
                            $fld2[$i] = $fld->[$1-1];
                        } else {
                            $fld2[$i] = $ix[$i];
                        }
                    }
                } else {
                    @fld2 = @$fld;
                }
                CSV::print($OUT, \@fld2);
                return 1;
            };
            CSV::iterate( $foundFile.'~', $work, $work);
            wprint("$foundFile:\n$n Sätze mit $answer umgeordnet\n");
            close $OUT;
            unlink $foundFile.'~' if $delori;
        },
        sub {
            $dialog->g_destroy;
            wprint("Abbruch\n");
        },
        whelp(),
    );
}
1;
__END__

=head1 reorder_columns

Vertauschen von Spalten einer csv-Datei

 Beispiel:
 Eingabdatei  : 11;12;13;3,14
 Tauschbefehl : 2003;#2;#1;#4
 Ausgabedatei : 2003;12;11;3,14
