use utf8;
use Style;

my $directory = syscfg::get('DEFAULTS.Directory', '');
my $foundFile = tkx()->getOpenFile(
    -initialdir  => ::OS::osPath($directory),
    -title => "bitte wählen sie die Eingabedatei"
);
if ($foundFile ne '') {
    my ($cmnts, $recs, $empty) = (0, 0, 0);
    my (@min, @max, $i, $sum);
    my $answer = '1,0';
    return 1 if (tkx()->askBox("Skalierung Datei",
        'ok',
        "Eingabe Korrekturfaktor (z.B. 0,9)",
        -textvariable => \$answer,
        -width => 20
    ) ne 'ok');
    my $factor = $answer + 0;
    my ($fn, $dir, $ext) = fileparse($foundFile, qr/\.[^.]*/x);
    my $outFile = tkx()->getSaveFile(
        -initialdir => $dir,
        -initialfile => $fn.'_scale'.$ext,
        -title => "bitte wählen Sie die Ausgabedatei"
    );
    if ($outFile ne '') {
        my $stz = CSV::STZ();
        die "can not overwrite\n" if $foundFile eq $outFile;
        open (my $O, '>', $outFile) or die "open $outFile $!";
        wprint("< $foundFile:\n");
        unless (CSV::iterate(
                $foundFile,
                sub {
                    my $fld = CSV::float(shift, \&Carp::croak);
                    $recs++;
                    wprint(join($stz, @$fld), "\n") if $recs <= 3;
                    $fld->[-1] *= $factor;
                    CSV::print($O, $fld);
                    return 1;
                },
                sub {
                    CSV::combine(@{$_[0]});
                    wprint(CSV::string());
                    print {$O} CSV::string();
                    return 1;
                }
            )) {
            wprint("$foundFile $!\n");
        }
        close $O;
        wprint("...\n");
        wprint("> $outFile\n");
        wprintf("%d Sätze mit Faktor %g skaliert\n", $recs, $factor);
    }
}
1;
__END__

=head1 scale

Skaliere alle Sätze einer Datei mit einem Faktor
