use utf8;
use Style;

my $pre = 'agg';
my $agg = 12;
my $aggpos  = 'agg12';   # 3 Geburtstyp,..., 12 Aggregat 1
my $percent = 1;         # 0 Änderung absolut, 1 Änderung in Prozent
my $minColorValue = '';  # Untergrenze für Wert für Farbe "blank" -> null
my $maxColorValue = '';  # Obergrenze  für Wert für Farbe "blank" -> null
my $maxDepth      = 1;   # Anzahl angezeigte Ebenen
my $maxPostDepth  = 0;   # Zusatz-Hinweis-Ebenen
my $hintOpacity   = 0.8; # Deckkraft

my ($dialog, $bframe) = ::tkx()->dialogbox('Kacheldiagramm');
my $entry = sub {
    my ($label, $varref, $width) = @_;
    $dialog->labelentry($label, -textvariable => $varref, -width => ($width // 10))->pack(-anchor => 'w');
};
my $title      = syscfg::get('DEFAULTS.Version', ''); # Titel
my $directory  = syscfg::get('DEFAULTS.Directory', '');
my $version    = syscfg::get('DEFAULTS.Version', '');
my $BASISJAHR  = vercfg::get('DEFAULTS.STARTJAHR', 1) - 1;
my $ENDJAHR    = vercfg::get('DEFAULTS.ENDJAHR', 1);
my $BASISTYP   = 'gem';
my $ENDTYP     = 'gem';
my $BASISDATEI = $BASISTYP.$BASISJAHR;
my $ENDDATEI   = $ENDTYP.$ENDJAHR;
$entry->('Titel', \$title, 60);
$entry->('Basisdatei', \$BASISDATEI);
$entry->('Vergleichsdatei', \$ENDDATEI);
$entry->('Spalte reftyp für Aggregat (3..12)',    \$aggpos);
$entry->('0: Änderung absolut, 1: Änderung prozentual', \$percent);
$entry->('Untergrenze Bevölkerungsänderung oder leer (minColorValue)', \$minColorValue);
$entry->('Obergrenze Bevölkerungsänderung oder leer (maxColorValue)', \$maxColorValue);
$entry->('Anzahl angezeigte Ebenen (1...) (maxDepth)',            \$maxDepth);
$entry->('Zusätzliche Hinweisebenen (0/1) (maxPostDepth)',        \$maxPostDepth);
$entry->('Hinweisdeckkraft (0.0 - 1.0) (hintOpacity)',            \$hintOpacity);
my @b = $bframe->okbutton(
    sub {
        $dialog->g_destroy;
        my $stz  = loc::get('record_separator');
        my $reftyp = reftyp->new();
        $BASISJAHR = $1 if $BASISDATEI =~ m/(\d\d\d\d)/;
        $BASISTYP  = $1 if $BASISDATEI =~ m/^(\D+)/;
        $ENDTYP    = $1 if $ENDDATEI   =~ m/^(\D+)/;
        my $refn = $reftyp->find($directory, $BASISJAHR);
        $reftyp->parse($refn, $stz);
        if ($aggpos =~ m/(\D*)(\d*)/) {
            $pre = $1;
            $agg = $2;
        }
        #say STDERR dump($pre, $agg);
        my $aggref = $reftyp->{columns}[$agg-1][3];
        my ($sum1, $gem1) = ptest::filehash($BASISDATEI, [], [2]);
        my ($sum2, $gem2) = ptest::filehash($ENDDATEI,   [], [2]);
        my $htm = $directory.$version.'/prot/treemap.htm';
        if (open(my $H, '>:utf8', $htm)) {
            no locale; # Dezimalpunkt für Javascript
            print {$H} << 'EOT';
<!DOCTYPE html>
<html>
<head>
<meta charset="utf-8">
<title>Kacheldiagramm</title>
<script type="text/javascript" src="https://www.google.com/jsapi"></script>
<script type="text/javascript">
google.load("visualization", "1", {packages:["treemap"]});
google.setOnLoadCallback(drawChart);
function drawChart() {
// Create and populate the data table.
var data = google.visualization.arrayToDataTable([
['Gebiet', 'Eltern', 'Ausgangsbevölkerung', 'Änderung', 'Endbevölkerung', 'Gebietsname'],
['Untersuchungsgebiet', null, null, null, null, null],
EOT
            my @agglist;
            if (ref($aggref) eq 'ARRAY') {
                @agglist = @$aggref;
            } else {
                @agglist = (1 .. $reftyp->{columns}[$agg-1][2]);
            }
            foreach (@agglist) {
                printf {$H} << 'EOT', $pre, $_;
['%s%s', 'Untersuchungsgebiet', null, null, null, null],
EOT
            }
            my ($minDelta, $maxDelta);
            foreach (0 .. scalar(@{$reftyp->{table}})-1) {
                my $GKZ = $reftyp->{table}[$_][0];
                my $NAM = $reftyp->{table}[$_][1];
                my $AGG;
                if (ref($aggref) eq 'ARRAY') {
                    $AGG = $aggref->[$reftyp->{table}[$_][$agg-1]-1];
                } else {
                    $AGG = $reftyp->{table}[$_][$agg-1];
                }
                # Delta to be shown as color
                my $Delta = 0;
                if ($BASISTYP eq $ENDTYP) {
                    my $Delta =  ($gem2->{$GKZ} // 0) - ($gem1->{$GKZ} // 0);
                    if ($percent) {
                        $Delta = 100 * $Delta / ($gem1->{$GKZ} // 1);
                    }
                } else {
                    $Delta = $gem2->{$GKZ} // 0; # z.B. ENDDATEI AQ2020 enthält Farbattribut Altenquotient
                }
                ($minDelta, $maxDelta) = minmax($minDelta // $Delta, $Delta, $maxDelta // $Delta);
                printf {$H} << 'EOT', $GKZ, $pre, $AGG, $gem1->{$GKZ} // 0, $Delta, ($BASISTYP eq $ENDTYP) ? ($gem2->{$GKZ} // '0') : 'null', $NAM;
['%d', '%s%s', %g, %g, %s, '%s'],
EOT
            }
            my $def = sub {
                my $s = shift;
                return $s =~ m/^\s*$/ ? 'null' : $s;
            };
            printf {$H} << 'EOT', $hintOpacity, $def->($minColorValue), $def->($maxColorValue), $maxDepth, $maxPostDepth, $title, $percent ? 'true' : 'false', $def->($minColorValue), $def->($maxColorValue), $percent ? '%' : '';
]);

// Create and draw the visualization.
var tree = new google.visualization.TreeMap(document.getElementById('chart_div'));
tree.draw(data, {
fontColor: 'black',
generateTooltip: showFullTooltip,
headerHeight: 15,
hintOpacity: %s,
minColorValue: %s,
maxColorValue: %s,
minColor: '#f00',
midColor: '#eee',
maxColor: '#0f0',
maxDepth: %s,
maxPostDepth: %s,
showScale: true,
title: '%s',
useWeightedAverageForAggregation: %s
});
function calcColor(row, value, minColorValue, maxColorValue) {
var col = data.getValue(row, 3);
if (col == null) {
    if ((minColorValue == null) && (maxColorValue == null)) {
        return '?';
    }
    if (value == 0) {
        return '&lt; ' + minColorValue;
    } else if (value == 1) {
        return '&gt; ' + maxColorValue;
    } else {
        return (minColorValue + value * (maxColorValue - minColorValue)).toFixed(2);
    }
} else {
    return col;
}
}
function showFullTooltip(row, size, value) {
var name = '', endbev = '', isAgg = 'durschnittliche ';
if (data.getValue(row, 4) != null) {
endbev = data.getColumnLabel(4) + ': ' + data.getValue(row, 4) + '<br>';
}
if (data.getValue(row, 5) != null) {
isAgg = '';
name = data.getColumnLabel(5) + ': ' + data.getValue(row, 5) + '<br>';
}
return '<div style="background:#fd9; padding:10px; border-style:solid">' +
        '<span style="font-family:Courier">' + row + ': <b>' + data.getValue(row, 0) +
        '</b>, ' + data.getValue(row, 1) + ', ' + data.getValue(row, 2) +
        ', ' + data.getValue(row, 3) + '</span><br>' +
        name +
        data.getColumnLabel(2) + ': ' + size + '<br>' +
        endbev +
        isAgg + data.getColumnLabel(3) + ': ' + calcColor(row, value, %s, %s) + '%s' + ' (Farbcode: ' + value + ')</div>';
}
}
</script>
</head>
<body>
<div id="chart_div" style="width: 900px; height: 500px;"></div>
EOT
            printf {$H} << 'EOT', $directory, $version, $BASISDATEI, $ENDDATEI, $agg, $percent ? 'prozentual' : 'absolut', $minDelta, $minColorValue, $maxColorValue, $maxDelta, $BASISJAHR, $ENDJAHR;
<p>%s%s, Basisdatei %s, Vergleichsdatei %s, Aggregatspalte reftyp %d,<br>
Änderung %s,<br>
Wertgrenzen für Farbe %s &le; %s .. %s &le; %s<br>
Mit linkem Mausklick vom Aggregat zum Gebiet, mit rechtem Mausklick zurück
<br>Die Fläche der Rechtecke entspricht der Bevölkerung aus gem%d,
die Farbe entspricht der Änderung zu gem%d<br>
Die erste Zeile Tooltip zeigt Gebietskennzeichen, Aggregatskennzeichen
und falls kein Aggregat Ausgangsbevölkerung und Änderung der Bevölkerung</p>
</body>
</html>
EOT
            close $H;
            OS::browse($htm);
        } else {
            wprint("open $htm $!\n");
        }
    },
    sub {
        $dialog->g_destroy;
        wprint("Abbruch\n");
    },
    ::whelp(),
);
Tkx::MainLoop();
1;
__END__

=head1 treemap

=for html
Kacheldiagramm aus Basis-gem-Datei, Vergleichs-gem-Datei und
reftyp mit Google Chart Tool
<a href="https://google-developers.appspot.com/chart/interactive/docs/gallery/treemap">Treemap</a>
<p>Dieses Kacheldiagramm visualisiert die Ebenen
<ol>
<li>Untersuchungsraum
<li>Typ/Aggregat (eine w&auml;hlbare Spalte aus reftyp)<br>
Achtung: die Schl&uuml;ssel Typ/Aggregat und Gebiet m&uuml;ssen disjunkt sein,
dies erreicht man z.B. durch den Pr&auml;fix 'agg' oder 'tyg' vor Typ/Aggregat!
<li>Gebiet (Gebietskennzeichen aus reftyp)
</ol>
der aktuellen Prognose.
<p>Die Gr&ouml;&szlig;e einer Kachel entspricht der Bev&ouml;lkerung
der Basis-gem-Datei eines Gebiets, Typs oder Aggregats.<br>
Wenn die Namen der Basisdatei und Vergleichsdatei vor der Jahreszahl
gleich sind (z.B. <code>gem</code>, dann entspricht
die Farbe der Zunahme/Abnahme der Vergleichsbev&ouml;lkerung
gegen&uuml;ber der Basisbev&ouml;lkerung absolut oder prozentual.<br>
Weicht der Name der Vergleichsdatei von der Basisdatei ab
(z.B. <code>farbcode2020</code>), so wird das Farbattribut
(z.B. Altenquotient, Ausl&auml;nderanteil, Frauen&uuml;berschuss, ...)
der Datei
<pre>farbcode.csv:
#Jahr;Gebietskennzeichen;Farbattribut
2010;101;-3,14
2010;102;15,32
...
</pre> entnommen.
Im Eingabefeld &Auml;nderung absolut/prozentual muss der Typ des Farbattributs
angegeben werden.
<p>Das Programm protokolliert Minimum/Maximum der &Auml;nderung der
Bev&ouml;lkerung bzw. des Farbattributs.
<p>minColorValue sollte man gr&ouml;&szlig;er als das Minimum angeben
(dann bedeutet rot <em>kleiner oder gleich minColorValue</em>,
maxColorValue sollte kleiner als das Maximum sein, dann bedeutet gr&uuml;n
<em>gr&ouml;&szlig;er oder gleich maxColorValue</em>.
<p>mit
<table>
<tr><th>1/2</th><td>Anzahl angezeigte Ebenen</td></tr>
<tr><th>0/1</th><td>Zus&auml;tzliche Hinweisebenen</td></tr>
</table>
k&ouml;nnen Sie Gebiet und Aggregat in einem Bild sehen.<br>
Siehe auch<br>
Visualisierung/Zeitreihen/Kacheldiagramm/aus gem+reftyp und<br>
<a href="http://sikurs.pthaug.de/done.htm#012">roadmap 012</a>
