use utf8;
use Style;

my $title = '';          # Titel
my $percent       = 1;   # Farbwertspalte 0 absolut, 1 prozentual
my $minColorValue = '';  # Minimum für Wert für Farbe "blank" -> null
my $maxColorValue = '';  # Maximim für Wert für Farbe "blank" -> null
my $maxDepth      = 1;   # Anzahl angezeigte Ebenen
my $maxPostDepth  = 0;   # Zusatz-Hinweis-Ebenen
my $hintOpacity   = 0.8; # Deckkraft
my $tooltip       = 1;   # 0 kein, 1 normal, 2 ausführlicher tooltip

my $directory = syscfg::get('DEFAULTS.Directory', '');
my $foundFile = ::tkx()->getOpenFile(
    -initialdir => ::OS::osPath($directory),
    -title => "please select treemap input file"
);
if ($foundFile ne '') {
    my ($dialog, $bframe) = ::tkx()->dialogbox('Kacheldiagramm');
    $dialog->g_wm_protocol('WM_DELETE_WINDOW', sub { $dialog->g_destroy; } );
    my $entry = sub {
        my ($label, $varref, $width) = @_;
        $dialog->labelentry($label, -textvariable => $varref, -width => ($width // 5))->pack(-anchor => 'w');
    };
    $entry->('Titel', \$title, 60);
    $entry->('Farbwertspalte 0 absolut, 1 prozentual', \$percent);
    $entry->('Minimum Farbwert oder leer (minColorValue)', \$minColorValue);
    $entry->('Maximum Farbwert oder leer (maxColorValue)', \$maxColorValue);
    $entry->('Anzahl angezeigte Ebenen (1...) (maxDepth)', \$maxDepth);
    $entry->('Zusätzliche Hinweisebenen (0/1) (maxPostDepth)', \$maxPostDepth);
    $entry->('Hinweisdeckkraft (0.0 - 1.0) (hintOpacity)', \$hintOpacity);
    $entry->('Tooltips (0 keine, 1 normal, 2 ausführlich)', \$tooltip);
    my @b = $bframe->okbutton(
        sub {
            $dialog->g_destroy;
            my $htm = $foundFile.'.htm';
            if (open(my $H, '>:utf8', $htm)) {
                no locale; # Dezimalpunkt für Javascript
                my $stz = CSV::STZ();        # vor locale 'C' setzen
                my ($min, $max);             # min/max Farbwert Daten
                print {$H} << 'EOT';
<!DOCTYPE html>
<html>
<head>
<meta charset="utf-8">
<title>Kacheldiagramm</title>
<script type="text/javascript" src="https://www.google.com/jsapi"></script>
<script type="text/javascript">
google.load("visualization", "1", {packages:["treemap"]});
google.setOnLoadCallback(drawChart);
function drawChart() {
// Create and populate the data table.
var data = google.visualization.arrayToDataTable([
EOT
                my $def = sub {
                    my $s = shift;
                    return $s =~ m/^\s*$/ ? 'null' : $s;
                };
                my $quote = sub {
                    my $s = shift;
                    return $s =~ m/^\s*$/ ? 'null' : q(').$s.q(');
                };
                my $num = sub {
                    my $s = shift;
                    return $. == 1 ? $quote->($s) : $s =~ m/^\s*$/ ? 'null' : $s =~ tr/,/./r;
                };
                CSV::iterate($foundFile,
                    sub {
                        my $l = shift;
                        my $col = $num->($l->[3]);
                        ($min, $max) = minmax($min // $col, $col, $max // $col) if ($. > 1) and ($col ne 'null');
                        printf {$H} qq([%s, %s, %s, %s],\n), $quote->($l->[0]), $quote->($l->[1]), $num->($l->[2]), $col;
                    },
                    sub {},
                    'trim' => 0
                );
                printf {$H} << 'EOT', $def->($minColorValue), $def->($maxColorValue), $maxDepth, $maxPostDepth, $hintOpacity, $title, $percent ? 'true' : 'false', $tooltip, $def->($minColorValue), $def->($maxColorValue);
]);
// Create and draw the visualization.
var tree = new google.visualization.TreeMap(document.getElementById('chart_div'));
tree.draw(data, {
minColorValue: %s,
maxColorValue: %s,
minColor: '#f00',
midColor: '#eee',
maxColor: '#0f0',
headerHeight: 15,
fontColor: 'black',
showScale: true,
maxDepth: %s,
maxPostDepth: %s,
hintOpacity: %s,
generateTooltip: showFullTooltip,
title: '%s',
useWeightedAverageForAggregation: %s
});
function calcColor(row, value, minColorValue, maxColorValue) {
var col = data.getValue(row, 3);
if (col == null) {
    if ((minColorValue == null) && (maxColorValue == null)) {
        return '?';
    }
    if (value == 0) {
        return '&lt; ' + minColorValue;
    } else if (value == 1) {
        return '&gt; ' + maxColorValue;
    } else {
        return (minColorValue + value * (maxColorValue - minColorValue)).toFixed(2);
    }
} else {
    return col;
}
}
function showFullTooltip(row, size, value) {
var verbose = %s;
var tip = '';
if (verbose > 0) {
tip += '<div style="background:#fd9; padding:10px; border-style:solid">'
}
if (verbose == 2) {
tip +=
'<span style="font-family:Courier">' + row + ': <b>' + data.getValue(row, 0) +
'</b>, ' + data.getValue(row, 1) + ', ' + data.getValue(row, 2) +
', ' + data.getValue(row, 3) + '<br>' +
value + ' Farbcode</span><br>';
}
if (verbose > 0) {
tip +=
data.getValue(row, 1) + '<br><b>' + data.getValue(row, 0) + '</b><br>' +
size + ' ' + data.getColumnLabel(2) + '<br>' +
calcColor(row, value, %s, %s) + ' ' + data.getColumnLabel(3) +
'</div>';
}
return tip;
}
}
</script>
</head>
<body>
<div id="chart_div" style="width: 900px; height: 500px;"></div>
EOT
                printf {$H} << 'EOT', $foundFile, $min, $def->($minColorValue), $def->($maxColorValue), $max;
<p>%s<br>
Wertebereich Farbe %g &lt; %s .. %s &lt; %g<br>
Mit linkem Mausklick eine Ebene tiefer, mit rechtem Mausklick zurück
</body>
</html>
EOT
                close $H;
                OS::browse($htm);
            }
        },
        sub {
            $dialog->g_destroy;
            wprint("Abbruch\n");
        },
        ::whelp(),
    );
    Tkx::MainLoop();
}
1;
__END__

=head1 treemap_csv

=for html
Kacheldiagramm (Beispiel
<a href="http://sikurs.pthaug.de/img/treemap_csv.htm">Zensus 2011</a>)
aus einer csv-Datei z.B. <code>treemap.csv</code> mit Google Chart Tool
<a href="https://google-developers.appspot.com/chart/interactive/docs/gallery/treemap">Treemap</a>
<p>Der Benutzer w&auml;hlt eine Kacheldiagrammbeschreibung, die nach folgendem
Schema die Informationen Aggregathierarchie, Kachelgr&ouml;&szlig;e und
Kachelfarbe bereitstellt:
<pre>treemap.csv:
S  ;V ;G ;F   ;Kommentar
UG ;  ;  ;    ;Untersuchunsgebiet ohne Vaterknoten
1  ;UG;  ;    ;Aggregat 1 unter UG
2  ;UG;  ;    ;
11 ;1 ;  ;    ;11 unter 1
12 ;1 ;  ;    ;
21 ;2 ;  ;    ;
25 ;2 ;  ;    ;
111;11;70;-5,1;111 unter 11 mit 70 Kachelgr&ouml;&szlig;e und -5 Kachelfarbe
112;11;60; 7,0;
121;12;40; 3,1;
122;12;50;-8,9;
214;21;30; 6,5;
217;21;65; 9,0;
252;25;75;-2,2;
253;25;20; 4,2;</pre>
Legende
<table>
    <tr><th>S</th><td>numerischer oder alphanumerischer Schl&uuml;ssel f&uuml;r Gebiet oder Aggregat</td></tr>
    <tr><th>V</th><td>Schl&uuml;ssel f&uuml;r zugeh&ouml;riges Aggregat</td></tr>
    <tr><th>G</th><td>Attribut f&uuml;r Kachelgr&ouml;&szlig;e (z.B. Ausgangsbev&ouml;lkerung)</td></tr>
    <tr><th>F</th><td>Attribut f&uuml;r Kachelfarbe (z.B. Bev&ouml;lkerungs-Zu/Abnahme, Altenquotient, ...)</td></tr>
</table>
Die Aggregate haben keine Werte f&uuml;r Gr&ouml;&szlig;e und Farbe,
weil diese &uuml;ber die zugeh&ouml;rigen Gebiete aggregiert werden.
F&uuml;r die Aggregation des Farbattributs ist die Angabe, ob es sich
um absolute oder prozentuale &Auml;nderungen handelt, notwendig.<br>
Die Schl&uuml;ssel f&uuml;r die Gebiete und Aggregate m&uuml;ssen
eindeutig sein.<br>
Aggregate k&ouml;nnen &uuml;ber beliebig viele Hierarchieebanen definiert werden
(z.B. Ortsbezirk, Gemeinde/Stadt, Verwaltungsverband, Landkreis, Bezirk,
Regierungsbezirk, Bundesland, ...)<br>
siehe auch<br>
Visualisierung/Zeitreihen/Kacheldiagramm/aus treemap.csv und
<a href="http://sikurs.pthaug.de/done.htm#012">roadmap 012</a>
