use utf8;
use Style;
use File::Basename;
use Data::Dump qw(dump);
use CSV;
use loc;

my $directory  = syscfg::get('DEFAULTS.Directory', '');
my $version    = syscfg::get('DEFAULTS.Version', '');
my $NAG = vercfg::get('METHODE.NAG', 100);
my $stz = CSV::STZ();
my $foundFile = tkx()->getOpenFile(
    -initialdir  => ::OS::osPath($directory),
    -title => "please select input file"
);
if ($foundFile ne '') {
    my ($cmnts, $recs, $empty) = (0, 0, 0);
    # wprint("Eingabe Korreturfaktor (z.B. 0,9): ");
    # my $answer = '0,75';
    my ($f, $d, $e) = fileparse($foundFile, qr/\.[^.]*/x);
    my $outFile = tkx()->getSaveFile(
        -initialdir  => $d,
        -initialfile => $f.'_norm.csv',
        -title => "please select output file"
    );
    if ($outFile ne '') {
        die "can not overwrite\n" if $foundFile eq $outFile;
        open (my $O, '>:encoding(UTF-8)', $outFile) or die "open $outFile $!";
        my @zuaq;
        my @tysu;
        my $pline = sub {
            my $fld = CSV::float(shift, \&Carp::croak);
            $recs++;
            wprint(join($stz, @$fld), "\n") if $recs <= 3;
            my $v = $fld->[5] + 0;
            $zuaq[$fld->[0]-1][$fld->[1]-1][$fld->[2]-1][$fld->[3]-1][$fld->[4]] = $v;
            $tysu[$fld->[0]-1][$fld->[2]-1][$fld->[3]-1][$fld->[4]] += $v;
            return 1;
        };
        my $pcmnt = sub {
            wprint(join($stz, @{$_[0]}), "\n");
            return 1;
        };
        wprint("< $foundFile:\n");
        if (CSV::iterate($foundFile, $pline, $pcmnt)) {
            # o.k.
        } else {
            wprint("$foundFile $!\n");
        }
        my $NTY = scalar @{$zuaq[0]};
        my @minmax = (1e30, -1e30);
        foreach my $tya (0 .. $#zuaq) {
            foreach my $ty (0 .. $#{$zuaq[$tya]}) {
                foreach my $bg (0 .. $#{$zuaq[$tya][$ty]}) {
                    foreach my $gg (0 .. $#{$zuaq[$tya][$ty][$bg]}) {
                        foreach my $ag (0 .. $NAG-1) {
                            my $nenner = $tysu[$tya][$bg][$gg][$ag] // 0;
                            $minmax[0] = $nenner if $nenner < $minmax[0];
                            $minmax[1] = $nenner if $nenner > $minmax[1];
                            my $wert   = 1/$NTY;
                            if ($nenner != 0) {
                                $wert = $zuaq[$tya][$ty][$bg][$gg][$ag]/$nenner;
                            }
                            print {$O} join($stz, $tya+1, $ty+1, $bg+1, $gg+1, $ag, $wert), "\n";
                        }
                    }
                }
            }
        }
        close $O;
        wprint("...\n");
        wprint("> $outFile\n");
        wprintf("%d Sätze mit Typsummen im Bereich %f .. %f skaliert\n", $recs, @minmax);
    } else {
        wprint("can not open $foundFile $!");
    }
}
1;
__END__

=head1 zuaq_norm

Normiere eine zuaq Datei, so dass die Summen pro Typ 1 sind
